//	File:		SerialArbitration.c
//	Purpose:	Serial arbitration routines
//	Author:		Form Macintosh developer CD sample code

// Comments beginning with -LR- are changes made to
// accomodate new Universal Headers

#include "SerialDriverArbitration.h"

// -LR-  Changed GestaltEqu.h to Gestalt.h
#include <Gestalt.h>
// -LR-  Changed SysEqu.h to LowMem.h
#include <LowMem.h>
#include <Devices.h>
#include <TextUtils.h>

//#include <stdio.h>

#define gestaltArbitorAttr 				'arb '
#define gestaltSerialArbitrationExists	0
#define dRAMBased		0x0040
#define dOpened			0x0020

// There is a bug in InterfaceLib on PowerPC machines.
// Certain low memory accessors were not included in
// InterfaceLib.  One of these accessors is LMGetUnitTableEntryCount
// The following routine is meant as a work-around for this
// problem.  You should remove this routine when Apple
// fixes the missing accessors.
// MAART: is fixed in OS8, removed accessor
#if 0 //defined(powerc) || defined (__powerc)
pascal short LMGetUnitTableEntryCount() 
{
	return (*(short*) 0x01D2);
}
#endif


// Test Gestalt to see if serial arbitration exists
// on this machine
Boolean SerialArbitrationExists(void)
{
	long	response;
	OSErr	err;
	
	err = Gestalt(gestaltArbitorAttr, &response);
	if (err)
		return false;
	return ((response >> gestaltSerialArbitrationExists) & 1);
}


Boolean CRMInstalled(void)
{
	long	response;
	OSErr	err;
	
	err = Gestalt(gestaltCRMAttr, &response);
	if (err)
		return false;
	return ((response >> gestaltCRMPresent) & 1);
}


Boolean DriverIsOpen(StringPtr driverName)
{
	Boolean canOpen = false;
	Boolean match = false;
	short	index = 0;
	short	count;
	DCtlHandle	dceHandle;
	StringPtr	namePtr;
	DCtlHandle	*theUnitTable;
	
	// -LR- changed this to a low memory accessor function
	count = LMGetUnitTableEntryCount();
	
	// -LR- changed this to a low memory accessor function
	theUnitTable = (DCtlHandle*)LMGetUTableBase();
	
	while ( !match && (index < count)) {
		// get handle to a device control entry
		dceHandle = theUnitTable[index];
		
		if (dceHandle) {
			if (!( (**dceHandle).dCtlFlags & dRAMBased) )
				// RAM based drivers have a handle to their driver
				namePtr = (StringPtr)(**dceHandle).dCtlDriver+18;
			else
				// ROM based drivers have a pointer to their driver
				namePtr = (StringPtr) (*(DCtlPtr)dceHandle).dCtlDriver+18;

			// not case sensitive, diacritical marks count
			if (RelString(driverName, namePtr, false, true) == 0) {
				match = true;
				canOpen = ((**dceHandle).dCtlFlags & dOpened) ? true : false;
			}
		}
		index++;
	}
	return canOpen;
}

