/******************************************************************************
 **																			 **
 ** 	Module:		DriverErrors.h											 **
 ** 																		 **
 ** 																		 **
 ** 	Purpose: 	Error codes for the driver								 **
 ** 																		 **
 ** 																		 **
 ** 	(C) 1997 Maarten Gribnau, m.w.gribnau@io.tudelft.nl					 **
 ** 																		 **
 ** 																		 **
 *****************************************************************************/
#pragma once

#ifndef DriverErrors_h
#define DriverErrors_h

typedef enum {
	err_BirdNotResponding = 50,
	err_IllegalMeasurementRate,
	err_Controller,
	err_AddressConfiguration,
	err_QD3DInitialise
} TBirdError;

/* Flock errors range from 1-35 */ 
#define IS_FLOCK_ERROR(a)		( ((a) > 0) && ((a) <= 35) )
#define IS_FLOCK_FATAL_ERROR(a)	( ((a) == 1) || ((a) == 2) || \
                                  ((a) == 15) || ((a) == 16) || \
                                  (((a) >> 20) && ((a) <= 27)))


#endif	// DriverErrors_h