/******************************************************************************
 **                                                                         **
 ** 	Module:		PrefFile.h                                              **
 **                                                                         **
 **                                                                         **
 **   Purpose:  Routines to handle preference files.                        **
 **                                                                         **
 **                                                                         **
 ** 	Maarten Gribnau.                                                    **
 **   m.w.gribnau@io.tudelft.nl                                             **
 **                                                                         **
 **                                                                         **
 *****************************************************************************/
#pragma once

#ifndef PrefFile_h
#define PrefFile_h

#include <Serial.h>
#include <Files.h>
#include "DriverBird.h"

typedef struct {
	short	           port;
	short              speed;
	TBirdConfiguration configuration;
	TBirdMode          mode;
	float              inch2qd3dX;
	float              inch2qd3dY;
	float              inch2qd3dZ;
	Boolean            controlCursor;
} TPreferences;


/******************************************************************************
 **																			 **
 **									 Routines								 **
 **																			 **
 *****************************************************************************/

void
GetPreferencesFile(
	OSType creator,
	ConstStr255Param name,
	FSSpec *spec);

OSErr
NewPreferencesFile(
	OSType creator,
	FSSpec *spec);

void
LoadPreferences(
	FSSpec *spec,
	TPreferences *prefs);

void
GetDefaultPreferences(
	TPreferences *prefs);

void
SavePreferences(
	FSSpec *spec,
	TPreferences *prefs);

#endif /* PreFile_h */