/******************************************************************************
 **                                                                         **
 ** 	Module:		PrefFile.h                                              **
 **                                                                         **
 **                                                                         **
 **   Purpose:  Routines to handle preference files.                        **
 **                                                                         **
 **                                                                         **
 ** 	Maarten Gribnau.                                                    **
 **   m.w.gribnau@io.tudelft.nl                                             **
 **                                                                         **
 **                                                                         **
 *****************************************************************************/

#ifndef PrefFile_h
#define PrefFile_h

#include <Serial.h>
#include <Files.h>

#include "DriverDynasight.h"

typedef TDynaConfiguration TPreferences;


/******************************************************************************
 **																			 **
 **									 Routines								 **
 **																			 **
 *****************************************************************************/

void
GetPreferencesFile(
	OSType creator,
	ConstStr255Param name,
	FSSpec *spec);

OSErr
NewPreferencesFile(
	OSType creator,
	FSSpec *spec);

void
LoadPreferences(
	FSSpec *spec,
	TPreferences *prefs);

void
SavePreferences(
	FSSpec *spec,
	TPreferences *prefs);


#endif /* PreFile_h */